public inbox for linux-xfs@vger.kernel.org
 help / color / mirror / Atom feed
From: Chandan Babu R <chandanrlinux@gmail.com>
To: fstests@vger.kernel.org
Cc: Chandan Babu R <chandanrlinux@gmail.com>,
	linux-xfs@vger.kernel.org, djwong@kernel.org
Subject: [PATCH V5 09/13] xfs: Check for extent overflow when writing to unwritten extent
Date: Mon,  8 Mar 2021 21:21:07 +0530	[thread overview]
Message-ID: <20210308155111.53874-10-chandanrlinux@gmail.com> (raw)
In-Reply-To: <20210308155111.53874-1-chandanrlinux@gmail.com>

This test verifies that XFS does not cause inode fork's extent count to
overflow when writing to an unwritten extent.

Signed-off-by: Chandan Babu R <chandanrlinux@gmail.com>
---
 tests/xfs/533     | 84 +++++++++++++++++++++++++++++++++++++++++++++++
 tests/xfs/533.out | 11 +++++++
 tests/xfs/group   |  1 +
 3 files changed, 96 insertions(+)
 create mode 100755 tests/xfs/533
 create mode 100644 tests/xfs/533.out

diff --git a/tests/xfs/533 b/tests/xfs/533
new file mode 100755
index 00000000..af7475f0
--- /dev/null
+++ b/tests/xfs/533
@@ -0,0 +1,84 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2021 Chandan Babu R.  All Rights Reserved.
+#
+# FS QA Test 533
+#
+# Verify that XFS does not cause inode fork's extent count to overflow when
+# writing to an unwritten extent.
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/inject
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+_supported_fs xfs
+_require_scratch
+_require_xfs_debug
+_require_xfs_io_command "falloc"
+_require_xfs_io_error_injection "reduce_max_iextents"
+
+echo "Format and mount fs"
+_scratch_mkfs_sized $((1024 * 1024 * 1024)) >> $seqres.full
+_scratch_mount >> $seqres.full
+
+bsize=$(_get_file_block_size $SCRATCH_MNT)
+
+testfile=${SCRATCH_MNT}/testfile
+
+echo "Inject reduce_max_iextents error tag"
+_scratch_inject_error reduce_max_iextents 1
+
+nr_blks=15
+
+for io in Buffered Direct; do
+	echo "* $io write to unwritten extent"
+
+	echo "Fallocate $nr_blks blocks"
+	$XFS_IO_PROG -f -c "falloc 0 $((nr_blks * bsize))" $testfile >> $seqres.full
+
+	if [[ $io == "Buffered" ]]; then
+		xfs_io_flag=""
+	else
+		xfs_io_flag="-d"
+	fi
+
+	echo "$io write to every other block of fallocated space"
+	for i in $(seq 1 2 $((nr_blks - 1))); do
+		$XFS_IO_PROG -f -s $xfs_io_flag -c "pwrite $((i * bsize)) $bsize" \
+		       $testfile >> $seqres.full 2>&1
+		[[ $? != 0 ]] && break
+	done
+
+	echo "Verify \$testfile's extent count"
+	nextents=$(xfs_get_fsxattr nextents $testfile)
+	if (( $nextents > 10 )); then
+		echo "Extent count overflow check failed: nextents = $nextents"
+		exit 1
+	fi
+
+	rm $testfile
+done
+
+# success, all done
+status=0
+exit
diff --git a/tests/xfs/533.out b/tests/xfs/533.out
new file mode 100644
index 00000000..5b93964a
--- /dev/null
+++ b/tests/xfs/533.out
@@ -0,0 +1,11 @@
+QA output created by 533
+Format and mount fs
+Inject reduce_max_iextents error tag
+* Buffered write to unwritten extent
+Fallocate 15 blocks
+Buffered write to every other block of fallocated space
+Verify $testfile's extent count
+* Direct write to unwritten extent
+Fallocate 15 blocks
+Direct write to every other block of fallocated space
+Verify $testfile's extent count
diff --git a/tests/xfs/group b/tests/xfs/group
index 77abeefa..3ad47d07 100644
--- a/tests/xfs/group
+++ b/tests/xfs/group
@@ -530,3 +530,4 @@
 530 auto quick punch zero insert collapse
 531 auto quick attr
 532 auto quick dir hardlink symlink
+533 auto quick
-- 
2.29.2


  parent reply	other threads:[~2021-03-08 15:52 UTC|newest]

Thread overview: 23+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2021-03-08 15:50 [PATCH V5 00/13] xfs: Tests to verify inode fork extent count overflow detection Chandan Babu R
2021-03-08 15:50 ` [PATCH V5 01/13] _check_xfs_filesystem: sync fs before running scrub Chandan Babu R
2021-03-08 17:50   ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 02/13] common/xfs: Add a helper to get an inode fork's extent count Chandan Babu R
2021-03-08 17:52   ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 03/13] common/xfs: Add helper to obtain fsxattr field value Chandan Babu R
2021-03-08 17:53   ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 04/13] xfs: Check for extent overflow when trivally adding a new extent Chandan Babu R
2021-03-08 18:08   ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 05/13] xfs: Check for extent overflow when growing realtime bitmap/summary inodes Chandan Babu R
2021-03-08 18:10   ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 06/13] xfs: Check for extent overflow when punching a hole Chandan Babu R
2021-03-08 15:51 ` [PATCH V5 07/13] xfs: Check for extent overflow when adding/removing xattrs Chandan Babu R
2021-03-08 15:51 ` [PATCH V5 08/13] xfs: Check for extent overflow when adding/removing dir entries Chandan Babu R
2021-03-08 18:15   ` Darrick J. Wong
2021-03-08 15:51 ` Chandan Babu R [this message]
2021-03-08 18:16   ` [PATCH V5 09/13] xfs: Check for extent overflow when writing to unwritten extent Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 10/13] xfs: Check for extent overflow when moving extent from cow to data fork Chandan Babu R
2021-03-08 18:18   ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 11/13] xfs: Check for extent overflow when remapping an extent Chandan Babu R
2021-03-08 18:19   ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 12/13] xfs: Check for extent overflow when swapping extents Chandan Babu R
2021-03-08 15:51 ` [PATCH V5 13/13] xfs: Stress test with bmap_alloc_minlen_extent error tag enabled Chandan Babu R

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20210308155111.53874-10-chandanrlinux@gmail.com \
    --to=chandanrlinux@gmail.com \
    --cc=djwong@kernel.org \
    --cc=fstests@vger.kernel.org \
    --cc=linux-xfs@vger.kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox